#include "IniFile.h"


CIniFile::CIniFile(TCHAR* FileName)
{
    // store file name
    _tcscpy(this->FileName,FileName);

    // directory must exists for IniFile (else WritePrivateProfileString can fail on some systems)
    CStdFileOperations::CreateDirectoryForFile(this->FileName);

    // set default section
    _tcscpy(this->CurrentSection,_T("Default"));
}
CIniFile::~CIniFile()
{

}

BOOL CIniFile::SetCurrentSectionName(TCHAR* CurrentSection)
{
    if ((_tcslen(CurrentSection)+1)>MAX_PATH)
        return FALSE;

    _tcscpy(this->CurrentSection,CurrentSection);
    return TRUE;
}

BOOL CIniFile::Set(TCHAR* Section,TCHAR* Name, TCHAR* Value)
{
    return ::WritePrivateProfileString(Section,Name,Value,this->FileName);
}
BOOL CIniFile::Set(TCHAR* Section,TCHAR* Name, DWORD Value)
{
    TCHAR szValue[64];
    _ultot(Value,szValue,10);
    return this->Set(Section,Name,szValue);
}
BOOL CIniFile::Set(TCHAR* Name, TCHAR* Value)
{
    return this->Set(this->CurrentSection,Name,Value);
}
BOOL CIniFile::Set(TCHAR* Name, DWORD Value)
{
    return this->Set(this->CurrentSection,Name,Value);
}

// return FALSE if string length is not enough
BOOL CIniFile::Get(TCHAR* Section,TCHAR* Name,TCHAR* DefaultValue,OUT TCHAR* Value,DWORD MaxValueSize)
{
    return (::GetPrivateProfileString(Section,Name,DefaultValue,Value,MaxValueSize,this->FileName)<(MaxValueSize-2));
}
BOOL CIniFile::Get(TCHAR* Section,TCHAR* Name,DWORD DefaultValue,OUT DWORD* pValue)
{
    *pValue=::GetPrivateProfileInt(Section,Name,DefaultValue,this->FileName);
    return TRUE;
}
BOOL CIniFile::Get(TCHAR* Name,TCHAR* DefaultValue, OUT TCHAR* Value,DWORD MaxValueSize)
{
    return this->Get(this->CurrentSection,Name,DefaultValue,Value,MaxValueSize);
}
BOOL CIniFile::Get(TCHAR* Name,DWORD DefaultValue, OUT DWORD* pValue)
{
    return this->Get(this->CurrentSection,Name,DefaultValue,pValue);
}